# coding: utf-8

"""
    NetHSM
    All endpoints expect exactly the specified JSON. Additional properties will cause a Bad Request Error (400). All HTTP errors contain a JSON structure with an explanation of type string. All [base64](https://tools.ietf.org/html/rfc4648#section-4) encoded values are Big Endian.   # noqa: E501
    The version of the OpenAPI document: v1
    Generated by: https://github.com/openapi-json-schema-tools/openapi-json-schema-generator
"""

from __future__ import annotations
from nethsm.client.shared_imports.schema_imports import *  # pyright: ignore [reportWildcardImportFromLibrary]


from nethsm.client.components.schema import base64
from nethsm.client.components.schema import sign_mode
Properties = typing.TypedDict(
    'Properties',
    {
        "mode": typing.Type[sign_mode.SignMode],
        "message": typing.Type[base64.Base64],
    }
)


class SignRequestDataDict(schemas.immutabledict[str, schemas.OUTPUT_BASE_TYPES]):

    __required_keys__: typing.FrozenSet[str] = frozenset({
        "message",
        "mode",
    })
    __optional_keys__: typing.FrozenSet[str] = frozenset({
    })
    
    def __new__(
        cls,
        *,
        message: str,
        mode: typing.Literal[
            "PKCS1",
            "PSS_MD5",
            "PSS_SHA1",
            "PSS_SHA224",
            "PSS_SHA256",
            "PSS_SHA384",
            "PSS_SHA512",
            "EdDSA",
            "ECDSA"
        ],
        configuration_: typing.Optional[schema_configuration.SchemaConfiguration] = None,
        **kwargs: schemas.INPUT_TYPES_ALL,
    ):
        arg_: typing.Dict[str, typing.Any] = {
            "message": message,
            "mode": mode,
        }
        arg_.update(kwargs)
        used_arg_ = typing.cast(SignRequestDataDictInput, arg_)
        return SignRequestData.validate(used_arg_, configuration=configuration_)
    
    @staticmethod
    def from_dict_(
        arg: typing.Union[
            SignRequestDataDictInput,
            SignRequestDataDict
        ],
        configuration: typing.Optional[schema_configuration.SchemaConfiguration] = None
    ) -> SignRequestDataDict:
        return SignRequestData.validate(arg, configuration=configuration)
    
    @property
    def message(self) -> str:
        return typing.cast(
            str,
            self.__getitem__("message")
        )
    
    @property
    def mode(self) -> typing.Literal["PKCS1", "PSS_MD5", "PSS_SHA1", "PSS_SHA224", "PSS_SHA256", "PSS_SHA384", "PSS_SHA512", "EdDSA", "ECDSA"]:
        return typing.cast(
            typing.Literal["PKCS1", "PSS_MD5", "PSS_SHA1", "PSS_SHA224", "PSS_SHA256", "PSS_SHA384", "PSS_SHA512", "EdDSA", "ECDSA"],
            self.__getitem__("mode")
        )
    
    def get_additional_property_(self, name: str) -> typing.Union[schemas.OUTPUT_BASE_TYPES, schemas.Unset]:
        schemas.raise_if_key_known(name, self.__required_keys__, self.__optional_keys__)
        return self.get(name, schemas.unset)
SignRequestDataDictInput = typing.Mapping[str, schemas.INPUT_TYPES_ALL]


@dataclasses.dataclass(frozen=True)
class SignRequestData(
    schemas.Schema[SignRequestDataDict, tuple]
):
    """NOTE: This class is auto generated by OpenAPI JSON Schema Generator.
    Ref: https://github.com/openapi-json-schema-tools/openapi-json-schema-generator

    Do not edit the class manually.
    """
    types: typing.FrozenSet[typing.Type] = frozenset({schemas.immutabledict})
    required: typing.FrozenSet[str] = frozenset({
        "message",
        "mode",
    })
    properties: Properties = dataclasses.field(default_factory=lambda: schemas.typed_dict_to_instance(Properties)) # type: ignore
    type_to_output_cls: typing.Mapping[
        typing.Type,
        typing.Type
    ] = dataclasses.field(
        default_factory=lambda: {
            schemas.immutabledict: SignRequestDataDict
        }
    )

    @classmethod
    def validate(
        cls,
        arg: typing.Union[
            SignRequestDataDictInput,
            SignRequestDataDict,
        ],
        configuration: typing.Optional[schema_configuration.SchemaConfiguration] = None
    ) -> SignRequestDataDict:
        return super().validate_base(
            arg,
            configuration=configuration,
        )

